\section{Refactoring}

\begin{quote}
	Programs, like people, get old. - David Lorge Parnas
\end{quote}

\subsection{Reasons to Refactor}
There are multiple reasons to refactor a software code. Some examples are: Under or over engineering, technical debt, etc. It is also good practice to refactor software, since we increase the quality of the overall product.

\paragraph{Finding Problems}

\begin{quote}
	Comments often are used as a deodorant. The comments are there because the code is so bad. - Martin Fowler
\end{quote}

\subsection{Code Smells}
A code smell is an indication that usually corresponds to a deeper problem in the system. Smells usually violate properties of Clean Code and/or Design Principles. Smells have names and thus foster communication.  Some smells are easy to detect: long method, large class. Smells have corresponding refactorings. 

There also is a code smell \href{catalog}{}. 

\subsection{Anit Patterns}
A common response to a recurring problem that is ineffective or contra productive. Inspired by Design Patterns, which describe successful solutions to recurring problems. And yes for sure also anti patterns have names.

\begin{itemize}
	\item Golden Hammer - Assuming that a favourite solution is universally applicable. 
	\item Not invented here - Belief that in-house developments are inherently better suited.
	\item Programming by Coincidence - Trying to approach a solution by trial and error. 
	\item Big ball of mud -  A system with no recognisable structure.
	\item There are many more...
\end{itemize} 

\subsection{Refactoring Code}
Refactoring is a disciplined technique for restructuring an existing body of code, altering its internal structure without changing its external behaviour. The whole purpose of refactoring is to make us program faster, producing more value with less effort.

Refactoring is not always the best solution.  If the code is FUBAR1, it might be easier and faster to rewrite it completely, works well if the software is loosely coupled. In any case, for time-consuming cleanups it is best to create separate work items.
 
\paragraph{How to refactor} \hfill \\
\begin{figure}[h!]
  \center
  \includegraphics[width=0.5\textwidth]{refactoring}
  \caption{Refactoring Workflow}
\end{figure}

\paragraph{Anatomy of Refactoring}
\begin{itemize}
	\itemsep -0.2em
	\item Name - build a common vocabulary, same idea as giving names to design patterns
	\item Summary - in which situation do you need it, what does it do?
	\item Motivation - Why should refactoring be done, when should refactoring not be done?
	\item Mechanism - How to carry out the refactoring?, Concise, step-by-step description
	\item Optional sections - Examples, inverse refactorings
\end{itemize}

\begin{figure}[h!]
  \center
  \includegraphics[width=0.75\textwidth]{examplerefactoring}
  \caption{Example Refactoring}
\end{figure}

\subsection{Legacy Code}
When we change code, we should have tests in place. To put tests in place, we often have to change code.

\begin{figure}[h!]
  \center
  \includegraphics[width=0.5\textwidth]{legacysteps}
  \caption{Three Universal Legacy Steps}
\end{figure}


